=== debian/changelog ===
openxr-sdk-source (1.0.20~dfsg1-1~nd120+1) bookworm; urgency=medium

  * Backported for bookworm.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Sat, 18 Feb 2023 23:40:10 -0500

openxr-sdk-source (1.0.20~dfsg1-1) unstable; urgency=medium

  * New upstream version 1.0.20~dfsg1. Highlights are primarily
    the addition of many new extensions in the headers.
  * Update patches.
  * Switch to using pandoc for markdown->html conversion
  * d/copyright: Update
  * Fix GCC 11 builds, closes #984278.

 -- Ryan Pavlik <ryan@ryanpavlik.com>  Mon, 25 Oct 2021 12:46:17 -0500

openxr-sdk-source (1.0.18~dfsg1-1) unstable; urgency=medium

  * New upstream version 1.0.18~dfsg1. Highlights include:
    - Many new extensions in the headers.
    - Validation layer fixes and defaulting to stdout output. (1.0.18)
    - New `XR_ERROR_RUNTIME_UNAVAILABLE` error code returned by
      a few loader-implemented OpenXR calls for clarification. (1.0.16)
    - Loader fix for explicit layer enumeration. (1.0.17)
    - Loader concurrency fixes. (1.0.16)
    - Headers no longer expose extension function prototypes by default:
      they are not exported by the loader, so having the prototypes can
      suggest they're available to use despite resulting in a link error.
      (1.0.15)
    - Deterministic build fixes. (1.0.15)
    - Improve exported CMake config files. (1.0.15)
  * d/watch: Update for manually uploaded tarballs now, fixing sig check
  * Rediff patches.
    - Drop 0005-Sort-protect-defines-to-permit-reproducible-builds.patch:
      Applied upstream
    - Drop 0004-add-check-for-shaderStorageImageMultisample-feature.patch:
      Applied upstream
  * d/copyright: Update
  * d/README.source: Update

 -- Ryan Pavlik <ryan@ryanpavlik.com>  Tue, 17 Aug 2021 13:50:00 -0500
